#import "StreamDelegate.h"


@implementation StreamDelegate
@synthesize iStream, oStream, sendnum;

- (void)initiate {
	NSHost *host = [NSHost hostWithAddress:@"127.0.0.1"];
	if (host != nil)
	{		
		// iStream and oStream are instance variables
		[NSStream getStreamsToHost:host port:7777 inputStream:&iStream outputStream:&oStream];
		
		//iStream is instance var of NSSInputStream
		[iStream retain];
		[iStream setDelegate:self];
		[iStream scheduleInRunLoop:[NSRunLoop currentRunLoop] forMode:NSDefaultRunLoopMode];
		[iStream open];
		
		//oStream is instance var of NSSOutputStream
		[oStream retain];
		[oStream setDelegate:self];
		[oStream scheduleInRunLoop:[NSRunLoop currentRunLoop] forMode:NSDefaultRunLoopMode];
		[oStream open];		
		
		NSError *streamError;
		streamError = [iStream streamError];
		streamError = [oStream streamError];
		
		NSStreamStatus streamStatus;
		streamStatus = [iStream streamStatus];
		streamStatus = [oStream streamStatus];
	}
}

- (void)stream:(NSStream *)theStream handleEvent:(NSStreamEvent)streamEvent
{
	NSString *io;
	if (theStream == iStream) io = @">>";
	else io = @"<<";
	
	NSString *event;
	switch (streamEvent)
	{
		case NSStreamEventNone:
			event = @"NSStreamEventNone";
			printf("Can not connect to the host!");
			break;
		case NSStreamEventOpenCompleted:
			event = @"NSStreamEventOpenCompleted";
			break;
		case NSStreamEventHasBytesAvailable:
			event = @"NSStreamEventHasBytesAvailable";
			if (theStream == iStream)
			{
				
				//read data
				uint8_t buffer[1024];
				int len;
				while ([iStream hasBytesAvailable])
				{
					len = [iStream read:buffer maxLength:sizeof(buffer)];
					if (len > 0)
					{
						NSString *output = [[NSString alloc] initWithBytes:buffer length:len encoding:NSASCIIStringEncoding]; //NSUTF8StringEncoding
						if (nil != output)
						{
							//do something with data
							NSLog(output);
						}
					}
				}
				 
			}
			break;
		case NSStreamEventHasSpaceAvailable:
			
			event = @"NSStreamEventHasSpaceAvailable";
			if (theStream == oStream)
			{
				NSString* test =[NSString stringWithFormat:@"Hello%d\r\n", sendnum];
				sendnum += 1;
				uint8_t buffer[test.length];
				for (int i = 0; i< [test length]; i++) {
					unichar charAscii = [test characterAtIndex:i];
					buffer[i] = charAscii;
				}
				
				int len;
				
				len = [oStream write:buffer maxLength:sizeof(buffer)];
				if (len > 0)
				{
					NSLog(@"Command sent: %@", test);
					//[oStream close];
				}
				
			}
            break;
		case NSStreamEventErrorOccurred:
			event = @"NSStreamEventErrorOccurred";
			printf("Can not connect to the host!");
			break;
		case NSStreamEventEndEncountered:
			event = @"NSStreamEventEndEncountered";
            [theStream close];
            [theStream removeFromRunLoop:[NSRunLoop currentRunLoop] forMode:NSDefaultRunLoopMode];
            [theStream release];
            theStream = nil;
			
			break;
		default:
			event = @"** Unknown";
	}
	
	NSLog(@"%@ : %@", io, event);
}

@end